#ifndef MPLIB1_BUILD_ARGV
#define MPLIB1_BUILD_ARGV
/*
*******************************************************************************
*  Copyright (c) 1997 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source$
*  $Author$
*  $Date$
*  $Revision$
*
*******************************************************************************
*
* Change History
*
* $Log$
*
*******************************************************************************
*/

#ident "$Header$"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#ifndef MPLIB1_DL_LIST
#include <mplib1/dl_list.h>
#endif

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

struct argv_track
{
dl_Node_t	v_node;
dl_List_t	m_track;
dl_List_t	v_parts;
dl_List_t	f_track;
char		**argv;
int		argc;
};

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

extern struct argv_track *build_argv_track( struct argv_track *argvtp, ... );
extern void free_argv_track( struct argv_track *argvtp );

#endif
/* -- End of File -- */
