#ifndef MPLIB1_PIDCHECK
#define MPLIB1_PIDCHECK
/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source$
*  $Author$
*  $Date$
*  $Revision$
*
*******************************************************************************
*
* Change History
*
* $Log$
*
*******************************************************************************
*/

#ident "$Header$"

/* #ifdef CXREF */
#include <sys/types.h>
/* #endif */

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

#ifndef PID_STR_LEN
#define PID_STR_LEN	12
#endif
#define GEN_MY_PID	((pid_t)-1)


/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

extern void gen_pid_str( char *buf, pid_t the_pid );

extern int is_pid_dead( pid_t the_pid );

#endif
/* -- End of File -- */
